package nccloud.api.gl.utils;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.gl.pfxx.GetBaseDAOUtil;
import nc.bs.gl.pfxx.MoneyToUpper;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.ui.pub.print.IDataSource;
import nc.ui.pub.print.IMetaDataDataSource;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.pub.lang.UFDouble;

import java.util.List;
import java.util.Map;


public class BillPdfDataSource implements IDataSource {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6613147708180615957L;
	BaseDAO dao = new BaseDAO();

	private VoucherVO vouchervo = null;
	private List<Map<String,String>> datas;

	public BillPdfDataSource(VoucherVO vouchervo,List<Map<String,String>> datas) {
		this.vouchervo = vouchervo;
		this.datas = datas;
	}

	@Override
	public String[] getItemValuesByExpress(String express) {
		String[] str ;
		if(express.equals("voucher56")){
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				str[i] = datas.get(i).get("explanation");
			}
		} else if (express.equals("voucher79")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				try {
					str[i] = GetBaseDAOUtil.getAccountName(datas.get(i).get("pk_accasoa"));
				} catch (Exception e) {
					throw new RuntimeException(e);
				}
			}
		} else if (express.equals("voucher76")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				str[i] = null;
			}
		} else if (express.equals("voucher304")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				try {
					str[i] = GetBaseDAOUtil.getCurrencyName(datas.get(i).get("pk_currtype"));
				} catch (Exception e) {
					throw new RuntimeException(e);
				}
			}
		} else if (express.equals("voucher75")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
//				str[i] = datas.get(i).get("debitamount").toString().equals("0.00000000")?new UFDouble(datas.get(i).get("creditamount").toString()).toString():new UFDouble(datas.get(i).get("debitamount").toString()).toString();
				Object debitamount = datas.get(i).get("debitamount");
				Object creditamount = datas.get(i).get("creditamount");
				str[i] = new UFDouble(debitamount.toString()).equals(UFDouble.ZERO_DBL)?creditamount.toString():debitamount.toString();
			}
		} else if (express.equals("voucher65")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				Object localdebitamount = datas.get(i).get("localdebitamount");
				str[i] = localdebitamount.toString();
			}
		} else if (express.equals("voucher69")) {
			str = new String[datas.size()];
			for(int i = 0;i < datas.size();i++){
				Object localcreditamount = datas.get(i).get("localcreditamount");
				str[i] = localcreditamount.toString();
			}
		} else if (express.equals("voucher36")) {
			str = new String[1];
			try {
				str[0] = GetBaseDAOUtil.getVoucherTypeName(this.vouchervo.getPk_vouchertype()) + "凭证";
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher43")) {
			str = new String[1];
			str[0] = null;
		} else if (express.equals("voucher16")) {
			str = new String[1];
			str[0] = this.vouchervo.getCreationtime().toString().substring(0,10);
		} else if (express.equals("voucher34")) {
			str = new String[1];
			str[0] = "总账";
		} else if (express.equals("voucher55")) {
			str = new String[1];
			try {
				str[0] = "核算账簿:"+GetBaseDAOUtil.getAccountBookName(this.vouchervo.getPk_accountingbook());
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher91")) {
			str = new String[1];
			str[0] = null;
		} else if (express.equals("voucher15")) {
			str = new String[1];
			String qrynum = "select num from gl_voucher where pk_voucher = '"+this.vouchervo.getPk_voucher()+"'";
			try {
				Object num = dao.executeQuery(qrynum,new ColumnProcessor());
				str[0] = num.toString();
			} catch (DAOException e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher92")) {
			str = new String[1];
			str[0] = "1";
		} else if (express.equals("voucher18")) {
			str = new String[1];
			str[0] = this.vouchervo.getAttachment().toString();
		} else if (express.equals("voucher42")) {
			str = new String[1];
			str[0] = this.vouchervo.getTotalcredit()== UFDouble.ZERO_DBL ?MoneyToUpper.moneyToUpper(this.vouchervo.getTotaldebit().toDouble()):MoneyToUpper.moneyToUpper(this.vouchervo.getTotaldebit().toDouble());
		} else if (express.equals("voucher31")) {
			str = new String[1];
			str[0] = this.vouchervo.getTotaldebit().toString();
		} else if (express.equals("voucher32")) {
			str = new String[1];
			str[0] = this.vouchervo.getTotalcredit().toString();
		} else if (express.equals("voucher39")) {
			str = new String[1];
			try {
				str[0] = GetBaseDAOUtil.getUserName(this.vouchervo.getPk_prepared());
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher38")) {
			str = new String[1];
			try {
				str[0] = GetBaseDAOUtil.getUserName(this.vouchervo.getPk_checked());
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher37")) {
			str = new String[1];
			try {
				str[0] = GetBaseDAOUtil.getUserName(this.vouchervo.getPk_casher());
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else if (express.equals("voucher40")) {
			str = new String[1];
			try {
				str[0] = GetBaseDAOUtil.getUserName(this.vouchervo.getPk_manager());
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		} else {
			str = new String[1];
			str[0] = null;
		}
		return str;
	}

	@Override
	public boolean isNumber(String s) {
		return false;
	}

	@Override
	public String[] getDependentItemExpressByExpress(String s) {
		return null;
	}

	@Override
	public String[] getAllDataItemExpress() {
		String[] dataItemExpress = new String[71];
		dataItemExpress[0] = "ADDCLASS";
		dataItemExpress[1] = "ADJUSTPERIOD";
		dataItemExpress[2] = "APPROVER";
		dataItemExpress[3] = "ATTACHMENT";
		dataItemExpress[4] = "BILLMAKER";
		dataItemExpress[5] = "CHECKEDDATE";
		dataItemExpress[6] = "CONTRASTFLAG";
		dataItemExpress[7] = "CONVERTFLAG";
		dataItemExpress[8] = "CREATIONTIME";
		dataItemExpress[9] = "CREATOR";
		dataItemExpress[10] = "DELETECLASS";
		dataItemExpress[11] = "DETAILMODFLAG";
		dataItemExpress[12] = "DISCARDFLAG";
		dataItemExpress[13] = "DR";
		dataItemExpress[14] = "ERRMESSAGE";
		dataItemExpress[15] = "ERRMESSAGEH";
		dataItemExpress[16] = "EXPLANATION";
		dataItemExpress[17] = "EXRATEDATE2";
		dataItemExpress[18] = "FREE1";
		dataItemExpress[19] = "FREE10";
		dataItemExpress[20] = "FREE2";
		dataItemExpress[21] = "FREE3";
		dataItemExpress[22] = "FREE4";
		dataItemExpress[23] = "FREE5";
		dataItemExpress[24] = "FREE6";
		dataItemExpress[25] = "FREE7";
		dataItemExpress[26] = "FREE8";
		dataItemExpress[27] = "FREE9";
		dataItemExpress[28] = "ISDIFFLAG";
		dataItemExpress[29] = "MODIFIEDTIME";
		dataItemExpress[30] = "MODIFIER";
		dataItemExpress[31] = "MODIFYCLASS";
		dataItemExpress[32] = "MODIFYFLAG";
		dataItemExpress[33] = "NUM";
		dataItemExpress[34] = "OFFERVOUCHER";
		dataItemExpress[35] = "PERIOD";
		dataItemExpress[36] = "PK_ACCOUNTINGBOOK";
		dataItemExpress[37] = "PK_CASHER";
		dataItemExpress[38] = "PK_CHECKED";
		dataItemExpress[39] = "PK_EXRATESCHEME2";
		dataItemExpress[40] = "PK_GROUP";
		dataItemExpress[41] = "PK_MANAGER";
		dataItemExpress[42] = "PK_ORG";
		dataItemExpress[43] = "PK_ORG_V";
		dataItemExpress[44] = "PK_PREPARED";
		dataItemExpress[45] = "PK_SETOFBOOK";
		dataItemExpress[46] = "PK_SOURCEPK";
		dataItemExpress[47] = "PK_SYSTEM";
		dataItemExpress[48] = "PK_VOUCHER";
		dataItemExpress[49] = "PK_VOUCHERTYPE";
		dataItemExpress[50] = "PREACCOUNTFLAG";
		dataItemExpress[51] = "PREPAREDDATE";
		dataItemExpress[52] = "SAGA_BTXID";
		dataItemExpress[53] = "SAGA_FROZEN";
		dataItemExpress[54] = "SAGA_GTXID";
		dataItemExpress[55] = "SAGA_STATUS";
		dataItemExpress[56] = "SIGNDATE";
		dataItemExpress[57] = "SIGNFLAG";
		dataItemExpress[58] = "TALLYDATE";
		dataItemExpress[59] = "TEMPSAVEFLAG";
		dataItemExpress[60] = "TOTALCREDIT";
		dataItemExpress[61] = "TOTALCREDITGLOBAL";
		dataItemExpress[62] = "TOTALCREDITGROUP";
		dataItemExpress[63] = "TOTALCREDITSETOFBOOK";
		dataItemExpress[64] = "TOTALDEBIT";
		dataItemExpress[65] = "TOTALDEBITGLOBAL";
		dataItemExpress[66] = "TOTALDEBITGROUP";
		dataItemExpress[67] = "TOTALDEBITSETOFBOOK";
		dataItemExpress[68] = "TS";
		dataItemExpress[69] = "VOUCHERKIND";
		dataItemExpress[70] = "YEAR";
		return dataItemExpress;
	}

	@Override
	public String[] getAllDataItemNames() {
		String[] dataItemNames = new String[71];
		dataItemNames[0] = "增加接口类";
		dataItemNames[1] = "调整期间";
		dataItemNames[2] = "审批人";
		dataItemNames[3] = "附单据数";
		dataItemNames[4] = "制单人";
		dataItemNames[5] = "审核日期";
		dataItemNames[6] = "对比标识";
		dataItemNames[7] = "折算凭证";
		dataItemNames[8] = "创建时间";
		dataItemNames[9] = "创建人";
		dataItemNames[10] = "删除接口类";
		dataItemNames[11] = "分录增删标志";
		dataItemNames[12] = "作废标志";
		dataItemNames[13] = "删除标识";
		dataItemNames[14] = "错误信息";
		dataItemNames[15] = "历史错误信息";
		dataItemNames[16] = "摘要";
		dataItemNames[17] = "记账日期2";
		dataItemNames[18] = "预留字段1";
		dataItemNames[19] = "预留字段10";
		dataItemNames[20] = "预留字段2";
		dataItemNames[21] = "预留字段3";
		dataItemNames[22] = "预留字段4";
		dataItemNames[23] = "预留字段5";
		dataItemNames[24] = "预留字段6";
		dataItemNames[25] = "预留字段7";
		dataItemNames[26] = "预留字段8";
		dataItemNames[27] = "预留字段9";
		dataItemNames[28] = "差异凭证";
		dataItemNames[29] = "修改时间";
		dataItemNames[30] = "修改人";
		dataItemNames[31] = "修改接口类";
		dataItemNames[32] = "修改标志";
		dataItemNames[33] = "凭证号";
		dataItemNames[34] = "冲销凭证";
		dataItemNames[35] = "会计期间";
		dataItemNames[36] = "核算账簿";
		dataItemNames[37] = "出纳";
		dataItemNames[38] = "审核人";
		dataItemNames[39] = "记账规则";
		dataItemNames[40] = "集团";
		dataItemNames[41] = "记账人";
		dataItemNames[42] = "组织";
		dataItemNames[43] = "组织多版本";
		dataItemNames[44] = "制单人";
		dataItemNames[45] = "账簿类型";
		dataItemNames[46] = "折算来源凭证";
		dataItemNames[47] = "制单系统";
		dataItemNames[48] = "凭证主键";
		dataItemNames[49] = "凭证类别";
		dataItemNames[50] = "提前关账科目";
		dataItemNames[51] = "制单日期";
		dataItemNames[52] = "子事务";
		dataItemNames[53] = "冻结状态";
		dataItemNames[54] = "全局事务";
		dataItemNames[55] = "事务状态";
		dataItemNames[56] = "签字日期";
		dataItemNames[57] = "签字标志";
		dataItemNames[58] = "记账日期";
		dataItemNames[59] = "暂存标志";
		dataItemNames[60] = "贷方合计";
		dataItemNames[61] = "全局贷方合计";
		dataItemNames[62] = "集团贷方合计";
		dataItemNames[63] = "账簿贷方合计";
		dataItemNames[64] = "借方合计";
		dataItemNames[65] = "全局借方合计";
		dataItemNames[66] = "集团借方合计";
		dataItemNames[67] = "账簿借方合计";
		dataItemNames[68] = "时间戳";
		dataItemNames[69] = "凭证类型";
		dataItemNames[70] = "会计年度";
		return dataItemNames;
	}

	@Override
	public String getModuleName() {
		return "20020PREPA";
	}

	public VoucherVO getVouchervo(){
		return vouchervo;
	}

	public void setVouchervo(VoucherVO vouchervo){
		this.vouchervo = vouchervo;
	}
}
